<template>
  <ob-form
      :form-data="formData"
      :form-model="formModel"
      :is-loading="isShowLoader"
      @submit="onSubmitHandler"
      okText="Подтвердить"
      data-qa="formClusterExpertPriceBP"
  >
    <div class="row">
      <div class="col-xs-12">
        <div class="service-block d-flex" v-if="service">
          <i class="icon resource__icon" v-html="getServiceIcon({ uuid: service.serviceTypeUuid }).icon"></i>
          <div class="title">
            <div>
              {{ service.directionTitle }}
              <template v-if="service.location">
                / {{ service.location }}
              </template>
            </div>
            <div v-if="service.service">
              {{ service.service.resourceSpeciesTitle }}
              {{ service.service.resourceSubtypeTitle }}
              {{ service.service.resourcePatternParameter }}
            </div>
            <div v-else>
              {{ service.serviceTitle }}
            </div>
          </div>
        </div>
        <div class="price-text">Все цены указаны без НДС</div>
      </div>
      <div class="col-xs-4" v-if="formData.directionUuid">
        <div class="form-group">
          <ob-input
              label="Экспертный тариф"
              type="money:2"
              subTitle="₽"
              v-model="formData.priceStage"
              :required="true"
              @input="updatePriceKm"
              data-qa="inputPriceStageBP"
          />
        </div>
      </div>
      <div :class="formData.directionUuid ? 'col-xs-4' : 'col-xs-6'">
        <div class="form-group">
          <ob-input
              label="Цена за км"
              subTitle="₽/км"
              type="money:2"
              v-model="formData.priceKm"
              ref="priceKm"
              :required="true"
              @input="updateStagePrice"
              data-qa="inputPriceKmBP"
          />
        </div>
      </div>
      <div class="col-xs-4" v-if="formData.directionUuid">
        <div class="form-group">
          <ob-input
              label="Расстояние"
              subTitle="км"
              type="number:strict"
              v-model="formData.distance"
              ref="distance"
              :disabled="true"
              :required="true"
              data-qa="inputDistanceBP"
          />
        </div>
      </div>
    </div>

    <transition name="fadeIn">
      <ObAlert
          v-if="error"
          :text="error"
          class="alert-error"
          theme="danger"
          icon="alert"
          :hide-close-button="true"
      />
    </transition>

  </ob-form>
</template>

<script>
import api from '@/api';
import FormValidationMixin from "common-components/src/obComponents/obForm/FormValidationMixin";
import ObForm from "common-components/src/obComponents/obForm";
import ObInput from "common-components/src/obComponents/obInput";
import ObAlert from "common-components/src/obComponents/obAlert";
import dropdownEvents from "@/mixins/dictionaries/dropdown-events";
import {required, requiredIf} from "vuelidate/lib/validators";
import { getServiceIcon } from '@/constants/order';

export default {
  name: "ClusterExpertPriceModal",
  components: {
    ObForm,
    ObInput,
    ObAlert,
  },
  mixins: [FormValidationMixin, dropdownEvents],
  props: {
    service: {
      type: Object,
      default: () => ({}),
    },
  },
  data () {
    return {
      error: '',
      isShowLoader: false,
    }
  },
  computed: {
    formModel() {
      return {
        priceStage: {
          value: null,
          validator: {
            required: requiredIf(function () {
              return this.formData.directionUuid;
            }),
          }
        },
        priceKm: {
          value: null,
          validator: {
            required
          }
        },
        distance: {
          value: null,
        },
        directionGroupUuid: {
          value: null,
        },
        directionUuid: {
          value: null,
        },
        resourcesGroupUuid: {
          value: null,
        },
        serviceUuid: {
          value: null,
        },
        locationFromUuid: {
          value: null,
        },
        locationToUuid: {
          value: null,
        },
      }
    },
  },
  methods: {
    getServiceIcon,
    async onSubmitHandler() {
      let params = {...this.formData};
      this.isShowLoader = true;
      try {
        await api.base_prices_clustering.setExpertPrice(params)
            .then((res) => {
              this.$notification({
                type: "system_notification_success",
                message: "Экспертная цена обновлена",
              });
              this.$emit("save", res);
            })
            .catch((err) => {
              if (err.error) {
                this.error = err?.error_message ? err?.error_message : err.error;
              }
            })
            .finally(() => {
              this.isShowLoader = false;
            });
      } catch (e) {
        this.isShowLoader = false;
        this.$notification({type: 'system_notification_error', message: 'Ошибка назначения экспертной цены'});
        this.error = 'Ошибка назначения экспертной цены';
      }
    },
    updateStagePrice() {
      if(this.formData.priceKm && this.formData.priceKm > 0 && this.formData.distance > 0) {
        this.formData.priceStage = this.formData.priceKm * this.formData.distance;
      } else {
        this.formData.priceStage = 0;
      }
      this.resetError();
    },
    updatePriceKm() {
      if(this.formData.priceStage && this.formData.priceStage > 0 && this.formData.distance > 0) {
        this.formData.priceKm =  Math.round(this.formData.priceStage / this.formData.distance);
      } else {
        this.formData.priceKm = 0;
      }
      this.resetError();
    },
    resetError() {
      this.error = '';
    },
    close() {
      console.log('123');
      this.resetError();
      this.$emit('close');
    },
  }
};
</script>

<style lang="scss">
@import "~common-components/src/static/css/mixins";
.form-group {
  justify-content: space-between;
  align-self: flex-start;
  margin-bottom: 20px;

  &__title {
    @include font-mixin(20px, 28px, 700, #191E32, 0.4px);
    margin-bottom: 10px;
  }

  &__label {
    @include font-mixin(14px, 18px, 400, #737682, 0.2px);
    margin-bottom: 15px;
  }

  .input-group .input{
    color: $cobalt-black;
  }
}

.service-block{
  display: flex;
  align-items: center;
  margin-bottom: 20px;

  .icon{
    margin-right: 15px;
  }

  .title{
    text-transform: uppercase;
    font-size: 12px;
    color: $cobalt-black;
  }
}

.price-text{
  color: $gray-slate;
  margin-bottom: 10px;
}
</style>